package com.winhc.task.common;

import com.alibaba.fastjson.JSONObject;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Map;
import java.util.function.Function;

/**
 * @author ZhangJi
 * @since 2021-10-22 11:13
 */
@Data
@NoArgsConstructor
public class MetaInfo {
    private CompanyInfo company;
    private ElasticSearchInfo es;
    private HbaseInfo hbase;
    private HologresInfo holo;

    public MetaInfo(CompanyInfo company, ElasticSearchInfo es, HbaseInfo hbase, HologresInfo holo) {
        this.company = company;
        this.es = es;
        this.hbase = hbase;
        this.holo = holo;
    }

    @Data
    @NoArgsConstructor
    public static class CompanyInfo {
        private String companyId;
        private String companyName;

        public CompanyInfo(String companyId, String companyName) {
            this.companyId = companyId;
            this.companyName = companyName;
        }
    }


    @Data
    @NoArgsConstructor
    public static class ElasticSearchInfo {
        private String index;
        private String type;

        private int version;

        public ElasticSearchInfo(String index, String type) {
            this.index = index;
            this.type = type;
            this.version = 0;
        }

        public ElasticSearchInfo(String index, String type, int version) {
            this.index = index;
            this.type = type;
            this.version = version;
        }
    }

    @Data
    @NoArgsConstructor

    public static class HbaseInfo {
        private String table;
        private String cf;
        private Function<JSONObject, JSONObject> handle;

        public HbaseInfo(String table, String cf) {
            this.table = table;
            this.cf = cf;
        }

        public HbaseInfo(String table, String cf, Function<JSONObject, JSONObject> handle) {
            this.table = table;
            this.cf = cf;
            this.handle = handle;
        }
    }

    @Data
    @NoArgsConstructor
    public static class HologresInfo {
        private String table;

        public HologresInfo(String table, String shema) {
            this.table = table;
            this.shema = shema;
        }

        private String shema;
    }

    @Data
    @NoArgsConstructor
    public static class GroupByInfo {
        private String field;
        private Map<String, String> value_alias;

        public GroupByInfo(String field, Map<String, String> value_alias) {
            this.field = field;
            this.value_alias = value_alias;
        }
    }

}
