package com.winhc.task.job;

import com.mongodb.client.MongoCollection;
import com.winhc.task.framework.es.EsFastScan;
import com.winhc.task.util.DateUtils;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.bson.Document;
import org.elasticsearch.client.RestHighLevelClient;
import org.elasticsearch.search.SearchHit;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.stereotype.Component;
import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.function.Consumer;
import java.util.stream.Collectors;

/**
 * @author: XuJiakai
 * 2020/11/16 20:03
 */
@Slf4j
@Component
@AllArgsConstructor
public class EsScanJobBack {
    private RestHighLevelClient restHighLevelClient;
    private final MongoTemplate mongoTemplate;


    public void start(String dsl, String tn, String index, String type, String tab) {
        String ymd = DateUtils.getYesterday_ymd();

        MongoCollection<Document> person = mongoTemplate.getCollection(tab);
        Consumer<SearchHit[]> func = list -> {
            List<Document> li = Arrays.stream(list).map(d -> {
                Map<String, Object> m1 = d.getSourceAsMap();
                String id = d.getId();
                Document document = new Document();
                // document.put("_id", id);
                //document.put("person_id", id);
                document.put("rowkey", id);
                document.put("ds", ymd);
                document.put("tn", tn);
                return document;
            }).collect(Collectors.toList());
            person.insertMany(li);
        };

        new EsFastScan(restHighLevelClient, func, index, type, dsl, null).scan();
    }

}
