package com.winhc.task.service;

import java.util.List;

/**
 * @Author: XuJiakai
 * @Date: 2020/10/21 09:04
 * @Description:
 */
public interface HbaseOperationService {

    /**
     * 批量删除某一行数据
     *
     * @param tableName
     * @param ids
     * @return
     */
    boolean deleteByRowkey(String tableName, List<String> ids);

    /**
     * 删除某一行数据
     *
     * @param tableName
     * @param id
     * @return
     */
    boolean deleteByRowkey(String tableName, String id);

    /**
     * 批量删除某一列数据
     *
     * @param tableName
     * @param ids
     * @param family
     * @param qualifier
     * @return
     */
    boolean deleteColsByRowkey(String tableName, List<String> ids, String family, String qualifier);

    /**
     * 删除某一列数据
     *
     * @param tableName
     * @param ids
     * @param family
     * @param qualifier
     * @return
     */
    boolean deleteColsByRowkey(String tableName, String ids, String family, String qualifier);

}
