package com.winhc.task.util;

import java.time.Instant;
import java.time.ZoneId;
import java.time.format.DateTimeFormatter;
import java.time.temporal.ChronoUnit;
import java.util.Locale;

/**
 * @Author: XuJiakai
 * @Date: 2020/7/20 13:48
 * @Description:
 */
public class DateUtils {
    private static final DateTimeFormatter df = DateTimeFormatter.ofPattern("yyyy-MM-dd")
            .withLocale(Locale.CHINA)
            .withZone(ZoneId.systemDefault());
    private static final DateTimeFormatter ymd_df = DateTimeFormatter.ofPattern("yyyyMMdd")
            .withLocale(Locale.CHINA)
            .withZone(ZoneId.systemDefault());

    public static String getYesterday() {
        Instant instant = Instant.now().minus(1, ChronoUnit.DAYS);
        return df.format(instant);
    }

    public static String getYesterday_ymd() {
        Instant instant = Instant.now().minus(1, ChronoUnit.DAYS);
        return ymd_df.format(instant);
    }

    public static String getMinusDay(Integer i) {
        Instant instant = Instant.now().minus(i, ChronoUnit.DAYS);
        return df.format(instant);
    }

    public static void main(String[] args) {
        System.out.println(getYesterday());
        System.out.println(getYesterday_ymd());
        System.out.println(getMinusDay(30));
    }
}
