package com.winhc.task.util;

import org.elasticsearch.script.Script;
import org.elasticsearch.script.ScriptType;
import org.elasticsearch.search.sort.ScriptSortBuilder;
import org.elasticsearch.search.sort.SortOrder;

import java.util.HashMap;
import java.util.Map;

/**
 * @author: XuJiakai
 * 2020/11/20 15:33
 */
public class SortUtil {
    public static class SingletonHolder {
        static SortUtil instance = new SortUtil();
    }

    public static SortUtil getInstance() {
        return SingletonHolder.instance;
    }




    public ScriptSortBuilder fastSort = new ScriptSortBuilder(new Script(ScriptType.INLINE, "painless", "return doc['company_score_weight'].value;", new HashMap<>()), ScriptSortBuilder.ScriptSortType.NUMBER).order(SortOrder.DESC);


    public ScriptSortBuilder fastDefaultSort() {
        Map<String, Object> params = new HashMap<>();
        String script_inline =
                "if(doc['cname.value.keyword'].value==null||doc['cname.value.keyword'].value.length()<=3){" +
                        "return 0.3;" +
                        "}" +
                        "if(doc['reg_status'].value==null || doc['reg_status'].value.contains('销')){" +
                        "return 1;" +
                        "}" +
                        "double a = doc['reg_capital_amount']==null?0.0:doc['reg_capital_amount'].value>1000000000000.0?1000000000000.0:doc['reg_capital_amount'].value;" +
                        "double w = Math.log(a/10000000+1)+1;" +
                        "if(doc['company_type'].value=='1'){" +
                        "w=w+3;" +
                        "}" +
                        "return w;";

        Script script = new Script(ScriptType.INLINE, "painless", script_inline, params);
        return new ScriptSortBuilder(script, ScriptSortBuilder.ScriptSortType.NUMBER).order(SortOrder.DESC);

    }

    public ScriptSortBuilder defaultSort() {
        Map<String, Object> params = new HashMap(12) {
            {
                put("xjk_company", "test");
            }
        };

        String script_inline = "if(doc['reg_status'].value==null || doc['reg_status'].value.contains('销')){        " +
                "return _score;  " +
                "}" +
                "double w = 1;" +
                "        if(doc['reg_capital_amount'].value!=null){" +
                "          w = Math.log(doc['reg_capital_amount'].value/10000000+1)+1;" +
                "        }" +
                "         if(doc['company_type'].value=='1'){" +
                "              w = w+3;" +
                "            }" +
                "double s = _score;" +
                "              if(doc['cname.value.keyword'].value==null||doc['cname.value.keyword'].value.length()<=3){" +
                "                s = Math.log(s+1);" +
                "              }" +
                "          return s*w;" +
                "";

        Script script = new Script(ScriptType.INLINE, "painless", script_inline, params);
        return new ScriptSortBuilder(script, ScriptSortBuilder.ScriptSortType.NUMBER).order(SortOrder.DESC);
    }


    public ScriptSortBuilder functionSort() {
        Map<String, Object> params = new HashMap<>();
        String inlineScript = "double s=doc['reg_capital_amount']==null?0.0:doc['reg_capital_amount'].value/100;double t=doc['estiblish_time']==null?0:doc['estiblish_time'].value;s=s>10000000000.0?10000000000.0:s;return (s/10000000+t/31536000000.0*2);";
        Script script = new Script(ScriptType.INLINE, "painless", inlineScript, params);
        return new ScriptSortBuilder(script, ScriptSortBuilder.ScriptSortType.NUMBER).order(SortOrder.DESC);
    }
}
