package com.winhc.task.util;

/**
 * @author: XuJiakai
 * 2021/2/3 10:41
 */

import cn.hutool.core.util.CharsetUtil;
import cn.hutool.crypto.symmetric.SymmetricAlgorithm;
import cn.hutool.crypto.symmetric.SymmetricCrypto;

import javax.crypto.spec.IvParameterSpec;
import java.nio.charset.StandardCharsets;

/**
 * @author: XuJiakai
 * 2021/2/3 11:44
 */

/**
 * AES加密模式：ECB
 * 填充：pkcs7（java中pkcs5等效果于pkcs7）
 * 数据块：128位（16字节）
 * 密码(key)【128/192/256比特，16/24/32字符】：winhc_168_000000
 * 偏移量(iv)【ecb模式下不用iv】：
 * 输出：hex
 * 字符集：utf-8
 */
public class WinhcCrypto {

    private static final String key = "winhc_168_000000";
    private static final String iv = "afasdfasdfasdfyu";
    private final SymmetricCrypto aes;


    public WinhcCrypto() {
        IvParameterSpec ivParameterSpec = new IvParameterSpec(WinhcCrypto.iv.getBytes(StandardCharsets.UTF_8));
        aes = new SymmetricCrypto(SymmetricAlgorithm.AES, key.getBytes(StandardCharsets.UTF_8));
//        aes = new SymmetricCrypto(SymmetricAlgorithm.AES.getValue(), KeyUtil.generateKey(SymmetricAlgorithm.AES.getValue(), key.getBytes(StandardCharsets.UTF_8)), ivParameterSpec);
    }

    public String encode(String content) {
        String encryptHex = aes.encryptHex(content);
        return encryptHex;
    }

    public String decode(String encryptHex) {
        String decryptStr = aes.decryptStr(encryptHex, CharsetUtil.CHARSET_UTF_8);
        return decryptStr;
    }


    public static void main(String[] args) {
        WinhcCrypto winhcCrypto = new WinhcCrypto();
        System.out.println(winhcCrypto.encode("你好"));
        String decode = winhcCrypto.decode("DA556055B35D6D3332D6776BF287D67D99E86C3383B3F9CDD14A64A6EBFF3C74");
        System.out.println(decode);
    }
}
