package com.winhc.task;

import com.alibaba.fastjson.JSON;
import com.winhc.task.bean.SynKafKaJobArgs;
import com.winhc.task.bean.TaskInfo;
import com.winhc.task.job.MultipleSynHoloJob;
import com.winhc.task.util.SchemaInit;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.Arrays;
import java.util.List;
import java.util.Set;

/**
 * @author π
 * @Description:
 * @date 2022/1/28 10:52
 */
@SpringBootTest
@Slf4j
public class BackSynKafkaData {
    @Autowired
    MultipleSynHoloJob multipleSynHoloJob;

    @Test
    public void start() {
        String project = "winhc_ng";
        String flow = "kafka_data_re_send";
        String taskName = "kafka_data_re_send_task";
        String topic = "test001";
        String beginDateTime = "20220126";
        String endDateTime = "20220129";
        String bizdate = "20220127";
        List<String> nodes = Arrays.asList("700005182395", "700005182396", "700005182398");
        List<String> tns2 = Arrays.asList("company_abnormal_info");
        SynKafKaJobArgs jobArgs2 = SynKafKaJobArgs.builder()
                .project(project)
                .flow(flow)
                .taskName(taskName)
                .nodeIds(nodes)
                .beginDateTime(beginDateTime)
                .endDateTime(endDateTime)
                .bizdate(bizdate)
                .topic(topic)
                .build();
        System.out.println(JSON.toJSONString(jobArgs2));
        System.out.println(SchemaInit.getJobs2(tns2, jobArgs2));
        multipleSynHoloJob.start(tns2, jobArgs2);
    }
}
