package com.winhc.task;

import com.winhc.task.util.CsvToXlsxUtil;

import java.io.File;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @author π
 * @Description:
 * @date 2022/11/7 16:10
 */
public class TransToExcelV2 {
    public static void main(String[] args) {
        String path = "D:\\data\\split5";
        toExcel(path);
    }

    public static void toExcel(String prefixPath) {
        String head = "企业名称,法定代表人,注册资本,成立日期,注吊销日期,登记状态,工商注册号,机构组织代码,统一社会信用代码,纳税人识别号,企业类型,所属行业,营业期限,核准日期,登记机关,省份代码,所属地区,详细地址,注册地址城市,经营范围,电话,更多电话,邮箱";
        List<List<String>> headList = Arrays.stream(head.split(","))
                .map(Collections::singletonList)
                .collect(Collectors.toList());

        //String path = "D:\\data\\split5";        //要遍历的路径
        File file = new File(prefixPath);        //获取其file对象
        File[] fs = file.listFiles();    //遍历path下的文件和目录，放在File数组中
        for (File f : fs) {                    //遍历File[]数组
            String csvFile = f.getAbsolutePath();
            if (!f.isDirectory()) {
                String fileName = f.getName();
                System.out.println(csvFile);
                CsvToXlsxUtil.jsonToXLSxPlus(csvFile, csvFile.replace(".json", ".xlsx")
                        , fileName.replaceAll(".json", ""), headList);
            }
        }
    }
}


