package com.winhc.task;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.aliyun.openservices.shade.org.apache.commons.lang3.StringUtils;
import com.winhc.task.bean.Company;
import com.winhc.task.bean.CompanyDevOut;
import com.winhc.task.common.CompanyChangeArgs;
import com.winhc.task.util.CsvToXlsxUtil;
import com.winhc.task.util.EasyExcelUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.*;
import java.util.function.Function;
import java.util.stream.Collectors;

import static com.winhc.task.util.CsvToXlsxUtil.jsonToXLSxChange;

/**
 * @author π
 * @Description: 数据测试
 * @date 2022/11/7 16:10
 */
public class TransToExcelV3 {
    private static final Logger log = LoggerFactory.getLogger(TransToExcelV3.class);

    public static void main(String[] args) {
        String tn = "company_dev";
        toExcel(tn);
    }

    public static void toExcel(String tn) {
        //输出表头
        String company_head = "自有企业id@公司名称@公司历史名称@注册号@公司类型@注册地址@注册时间@营业时间开始日期@营业时间结束日期" +
                "@经营范围@登记机关@核准日期@企业状态@注册资本@组织机构代码@组织机构代码批准单位@机构类型@统一信用代码@省份code@市code@县区code@注册资本金额" +
                "@注册资本币种@实收资本金额@实收资本币种@公司注册状态标准化@职工参保人数@注销时间@注销原因@吊销时间@吊销原因@创建时间@是否删除@更新时间@法人信息";

        List<List<String>> headList = Arrays.stream(company_head.split("@"))
                .map(Collections::singletonList)
                .collect(Collectors.toList());

        Map<String, CompanyChangeArgs> exportArgs = CompanyChangeArgs.EXPORT_ARGS;
        CompanyChangeArgs args = exportArgs.get(tn);
        Function<JSONObject, JSONObject> handles = args.getHandles();

        String objectName = "tmp/test/company.json";
        String outPathPre = "D:\\tmp\\data\\";
        String outPath = outPathPre + "company_agg.xlsx";
        jsonToXLSxChange(tn, outPath, objectName, headList, args.getClazz(), handles, null);

    }

}


